from .additions.early_fusion_from_monoview import BaseEarlyFusion
from ..utils.hyper_parameter_search import CustomRandint, CustomUniform

# from ..utils.dataset import get_v

classifier_class_name = "EarlyFusionIBRSCM"


class EarlyFusionIBRSCM(BaseEarlyFusion):

    def __init__(self, random_state=None, n_estimators=10,
                 sampling_strategy="auto", replacement=False, **kwargs):
        BaseEarlyFusion.__init__(self, random_state=random_state,
                                 monoview_classifier="ib_random_scm",
                                 n_estimators=n_estimators,
                                 sampling_strategy=sampling_strategy,
                                 replacement=replacement,
                                 **kwargs)
        self.param_names = ["n_estimators", "sampling_strategy",
                            "base_estimator__n_estimators",
                            "base_estimator__max_rules",
                            "base_estimator__max_samples",
                            "base_estimator__max_features",
                            "base_estimator__model_type",
                            "base_estimator__p_options",
                            'random_state']
        self.classed_params = []
        self.distribs = [CustomRandint(low=1, high=50),
                         ["auto"],CustomRandint(low=1, high=300),
                         CustomRandint(low=1, high=20),
                         CustomUniform(), CustomUniform(),
                         ["conjunction", "disjunction"], CustomUniform(),
                         [random_state]]
        self.weird_strings = {}