from .additions.early_fusion_from_monoview import BaseEarlyFusion
from ..utils.base import base_boosting_estimators
from ..utils.hyper_parameter_search import CustomRandint, CustomUniform

classifier_class_name = "EarlyFusionImbalanceBagging"


class EarlyFusionImbalanceBagging(BaseEarlyFusion):

    def __init__(self, random_state=None, base_estimator="DecisionTreeClassifier",
                 n_estimators=10, sampling_strategy="auto",
                 replacement=False, base_estimator_config=None, **kwargs):
        BaseEarlyFusion.__init__(self, random_state=random_state,
                                 monoview_classifier="imbalance_bagging",
                                 base_estimator=base_estimator,
                 n_estimators=n_estimators, sampling_strategy=sampling_strategy,
                 replacement=replacement, base_estimator_config=base_estimator_config, **kwargs)
        self.param_names = ["n_estimators", "base_estimator",
                            "sampling_strategy", ]
        self.classed_params = ["base_estimator"]
        self.distribs = [CustomRandint(low=1, high=50),
                         base_boosting_estimators,
                         ["auto"]]
        self.weird_strings = {"base_estimator": "class_name"}
        self.base_estimator_config = base_estimator_config