from .additions.early_fusion_from_monoview import BaseEarlyFusion
from ..utils.hyper_parameter_search import CustomUniform, CustomRandint

classifier_class_name = "EarlyFusionSCM"


class EarlyFusionSCM(BaseEarlyFusion):

    def __init__(self, random_state=None, model_type="conjunction",
                 max_rules=10, p=0.1, **kwargs):
        BaseEarlyFusion.__init__(self, random_state=None,
                                    monoview_classifier="scm",
                                 model_type=model_type,
                                 max_rules=max_rules, p=p, **kwargs)
        self.param_names = ["model_type", "max_rules", "p", "random_state"]
        self.distribs = [["conjunction", "disjunction"],
                         CustomRandint(low=1, high=15),
                         CustomUniform(loc=0, state=1), [random_state]]
        self.classed_params = []
        self.weird_strings = {}